use flax::{entity_ids, BoxedSystem, Query, QueryBorrow, Schedule, System, World};

use crate::core::module::Module;

pub mod events;

pub struct RenderModule {
}

impl RenderModule {
    pub fn new(
        schedule: &mut Schedule,
        _world: &mut World,
        _events: &mut crate::core::events::Events,
    ) -> Self {
        let schedule_r = Schedule::builder()
            .with_system(add_distance_system())
            .build();
        schedule.append(schedule_r);
        Self {

        }
    }
}

impl Module for RenderModule {
    fn on_update(
        &mut self,
        _world: &mut World,
        _events: &mut crate::core::events::Events,
        _frame_time: std::time::Duration,
    ) -> anyhow::Result<()> {
        // println!("RenderModule on_update");

        
        Ok(())
    }
}

pub fn add_distance_system() -> BoxedSystem {
    let query = Query::new(entity_ids());

    System::builder()
        .with_query(query)
        .build(|mut query: QueryBorrow<'_, flax::EntityIds, _>| {
            for _id in &mut query {
                // println!("entity id: {}", id.index());
            }
        })
        .boxed()
}
